//Tarundeep Kaur 

#include"rfid.h"
#include <LiquidCrystal_I2C.h>
#include <Wire.h>
#include <Servo.h>

LiquidCrystal_I2C lcd(0x27,16,2);
Servo servo; 

RFID rfid; //create a variable type of RFID

#define relayPin 8  //relay module attach to pin8
#define SERVO 9 //servo motor attached to pin9
#define buzzerPin 10

uchar serNum[5]; // array to store your ID
int counter = 2; //counts the number of tried attempted
void setup()
{
  lcd.init(); //initialize lcd
  lcd.backlight(); //turn on the backlight
  Serial.begin(9600);
  
  servo.attach(SERVO);
  
  rfid.begin(7, 5, 4, 3, 6, 2);//rfid.begin(IRQ_PIN,SCK_PIN,MOSI_PIN,MISO_PIN,NSS_PIN,RST_PIN)
  delay(100); 
  rfid.init(); //initialize the RFID
  
  pinMode(relayPin, OUTPUT);  //set relayPin as OUTPUT
  digitalWrite(relayPin,HIGH); //and high level

  servo.write(180.0);
  lcd.setCursor(0,0);
  lcd.print("     LOCKED     ");
  lcd.setCursor(0,1);
  lcd.print("Tap in to unlock");
  delay(2000);//delay 2s

  pinMode(buzzerPin, OUTPUT); 
}

void loop()
{
  tone(A0, 15, 50);
  
  uchar status;
  uchar str[MAX_LEN];
   // Search card, return card types
  status = rfid.request(PICC_REQIDL, str);
  if (status != MI_OK)
  {
    return;
  }
  // Show card type
  rfid.showCardType(str);
  //Prevent conflict, return the 4 bytes Serial number of the card
  status = rfid.anticoll(str);
//r1 
  if (status == MI_OK)
  {
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print(" ID:  ");
    memcpy(serNum, str, 5);
    rfid.showCardID(serNum);//show the card ID

    // Check people associated with card ID
    uchar* id = serNum;
    if( id[0]==0xB5 && id[1]==0xE7 && id[2]==0xFB && id[3]==0xD1 ) //r1
    //if the card id is B5E7FBD1,then relay connect 
    {
      counter = 2;
      digitalWrite(relayPin,LOW);
      
      lcd.setCursor(0,1);
      lcd.print("Welcome home TK!");
      enterance(); 
      
      delay(500);
      lock();  //lock function called 
      delay(5000);
      
      lcd.clear();
      digitalWrite(relayPin,HIGH);
    } 
    else if(id[0]==0x05 && id[1]==0xEC && id[2]==0xF3 && id[3]==0xD1) //r2
    //if the card id is 05ECF3D1,then relay connect 
    {
      counter = 2;
      digitalWrite(relayPin,LOW);
      
      lcd.setCursor(0,1);
      lcd.print("Welcome home RK!");
      
      enterance();
      delay(500);
      lock(); //lock function called 
      delay(5000);
      
      lcd.clear();
      digitalWrite(relayPin,HIGH);
    } 
    else
    //if not one of those 2 card id's ERROR signal shown. 
    {
      lcd.setCursor(0,0);
      lcd.print("ERROR. Try again.");
      lcd.setCursor(0,1);
      counter--;
      lcd.print(" Tries left: ");
      lcd.print(counter);
      delay(5000);
      lcd.clear();
      alarm();
    }
  }
  lcd.setCursor(0,0);
  lcd.print("     LOCKED     ");
  lcd.setCursor(0,1);
  lcd.print("Tap in to unlock");
  delay(2000);
  rfid.halt(); //command the card into sleep mode 
}

void lock() //control's and opens the lock
{
   servo.write(0.0); 
   delay(5900); 
   servo.write(180.0);
}

void alarm() //alarm function is called when incorrect card id is used
{
  if (counter == 1) 
    intruder();
  if (counter == 0)
  { 
    intruder(); 
    delay(750); 
    intruder(); 
    delay(750); 
    intruder(); 
    counter = 2;
  }
}

void enterance() //function used by buzzer to signify correct id and door opening. 
{
  tone(buzzerPin, 1318, 150);   //E6
  delay(175);
  tone(buzzerPin, 1567, 150);   //G6
  delay(175);
  tone(buzzerPin, 2637, 150);   //E7
  delay(175);
  tone(buzzerPin, 2093, 150);   //C7
  delay(175);
  tone(buzzerPin, 2349, 150);   //D7
  delay(175);
  tone(buzzerPin, 3135, 500);   //G7
  delay(500);
}

void intruder() //function used by buzzer to signify wrong id used and more than 2 incorrect trials. 
{
  tone(buzzerPin, 130, 250);   //E6
  delay(275);
  tone(buzzerPin, 73, 250);   //G6
  delay(275);
  tone(buzzerPin, 65, 150);   //E7
  delay(175);
  tone(buzzerPin, 98, 500);   //C7 
}
